<!-- TODO: translate! -->
<template>
  <div class="dsd-item dv-preview-container">
    <h2
      class="mb-lg-4 mt-lg-4"
      data-toggle="tooltip"
      data-placement="top"
      data-cy="dataset-distribution-preview"
    >
      Preview of <em> {{ title }} </em>
    </h2>
    <div v-if="loading">
      <div class="d-flex" style="position: relative; height: 150px;">
        <div class="ecl-spinner ecl-spinner--primary ecl-spinner--m ecl-spinner--centered ecl-spinner--visible" role="alert">
          <svg class="ecl-spinner__loader" viewBox="25 25 50 50">
            <circle class="ecl-spinner__circle" cx="50" cy="50" r="20" fill="none" stroke-width="4px" stroke-miterlimit="10"
              vector-effect="non-scaling-stroke" />
          </svg>
          <div class="ecl-spinner__text">Loading</div>
        </div>
      </div>
    </div>
    <div v-else-if="invalidFile" class="dsd-banners">
      <!-- <ECInfo type="info" title="Details:" :message="errorMessage"> -->
      <ECInfo
        type="info"
        title="Details:"
        message="The source file is currently inaccessible"
      >
        We're sorry, but previewing this file is currently not possible.
        <br />
        <br />
      </ECInfo>
    </div>

    <!-- Card -->
    <div v-else>
      <div v-if="this.jsonData" class="dv-card card text-center">
        <!-- Card Header (Navigation bar) -->
        <dv-nav-bar @showTab="showTab" :activeTab="activeTab"></dv-nav-bar>

        <!-- Card Body -->
        <div class="card-body">
            <!-- Tab for Table View -->
          <dv-tabular-view
            v-if="activeTab == 'table-view'"
            role="tabpanel"
            id="dv-table-view"
            :columnTitles="allLabels"
            :rowData="dataRows"
          >
          </dv-tabular-view>
          <!-- Tab for Numerical Charts -->
          <dv-numerical-view
            v-else-if="activeTab == 'numerical'"
            role="tabpanel"
            :showNumTabContent="showNumTabContent"
            :categoricalLabels="categoricalLabels"
            :numericalLabels="numericalLabels"
            :xPicked="xPicked"
            :yPicked="yPicked"
            :viewType="viewType"
            :viewTypes="viewOptions.map((e) => e.label)"
            :chartData="dataCollection"
            :chartOptions="options"
            @updateXPicked="updateXPicked"
            @updateYPicked="updateYPicked"
            @removeChart="removeChart"
          />
          <!-- Tab for Categorical Charts -->
          <dv-categorical-view
            v-else-if="activeTab == 'categorical'"
            role="tabpanel"
            :showCatTabContent="showCatTabContent"
            :labels="categoricalLabels"
            :yPicked="catYPicked"
            :viewType="catViewType"
            :viewTypes="catViewOptions.map((e) => e.label)"
            :chartData="catDataCollection"
            :chartOptions="options"
            @updateYPicked="updateCatYPicked"
            @removeChart="removeChart"
          />
        </div>
      </div>

      <!-- Records range bar -->
      <div class="dv-records-range-container text-right">
        <small class="dv-records-range-container-record-number mr-1"
          >{{ this.dataRows.length }} Records</small
        >
        <small v-if="activeTab === 'numerical' && showNumTabContent">
          <label for="from">show records from</label>
          <input
            @change="updateRange"
            type="number"
            id="from"
            v-model.number="fromIndex"
            min="1"
          />
          <label for="to">-</label>
          <input
            @change="updateRange"
            type="number"
            id="to"
            v-model.number="toIndex"
            :min="fromIndex"
            :max="this.dataRows.length"
          />
        </small>
      </div>

      <br />

      <!-- Feedback Tool -->
      <dv-feedback-tool
        :downloadUrl="downloadUrl"
        :allChartOptions="allChartOptions"
        :allLabels="allLabels"
        :numericalLabels="numericalLabels"
        :categoricalLabels="categoricalLabels"
        :defaultSuggestedChartType="defaultSuggestedChartType"
        :defaultSuggestedX="defaultSuggestedX"
        :defaultSuggestedY="defaultSuggestedY"
      />
    </div>
  </div>
</template>

<script>
import axios from "axios";
import ECInfo from "../ECInfo.vue"
import DvNavBar from "./DvNavBar.vue";
import DvNumericalView from './DvNumericalView.vue';
import DvCategoricalView from "./DvCategoricalView.vue";
import DvTabularView from "./DvTabularView.vue";
import DvFeedbackTool from "./DvFeedbackTool.vue";

export default {
  name: "DistributionVisualisation",
  components: {
    ECInfo,
    DvNavBar,
    DvNumericalView,
    DvCategoricalView,
    DvTabularView,
    DvFeedbackTool,
  },
  props: {
    title: String,
    downloadUrl: String,
    format: String,
  },
  data() {
    return {
      // print: false,
      invalidFile: null,
      loading: true,
      errorMessage: '',
      jsonData: null,
      activeTab: "",
      allLabels: [],
      categoricalLabels: [],
      numericalLabels: [],
      fromIndex: 1,
      toIndex: null,
      viewOptions: [
        { value: "Bar", label: "Bar" },
        { value: "Line", label: "Line" },
      ],
      showNumTabContent: true,
      chartLabels: [],
      viewType: "",
      xPicked: "",
      yPicked: [], // multiple y labels can be picked --> Array of strings
      xLabels: [],
      dataCollection: {},
      datasets: [], // dataRows, label, backgroundColor
      dataRows: [], // only the data arrays
      hideXLabels: false,

      catViewOptions: [
        { value: "Bar", label: "Bar" },
        // { value: "Pie", label:"Pie" },
        // { value: "Line", label:"Line" },
        { value: "Doughnut", label: "Doughnut" },
      ],
      showCatTabContent: true,
      nCatToShow: 100, // TODO: tell that not all categories are shown (in tooltip for example)
      catChartValues: [],
      catYValues: [],
      catViewType: "",
      catYPicked: "", // only Y, because X will be automatically generated from the categories of Y
      catDataCollection: {},
      catDatasets: [], // dataRows, label, backgroundColor
      categorizedData: [],

      currentPage: 1,
      totalPages: 0,
      options: {
        responsive: true,
        // maintainAspectRatio: false,
        scales: {
          // yAxes: {
          //     beginAtZero: false
          // },
          x: {
            ticks: {
              maxTicksLimit: 20,
            },
          },
        },
        plugins: {
          legend: {
            onClick: (e, legendItem) => {
              // this.removeChart(legendItem.text)
            },
            display: true,
            labels: {
              borderRadius: 10,
              useBorderRadius: true,
              pointStyle: "circle",
              usePointStyle: true,
              padding: 20,
            },
          },
        },
      },
      // Feedback tool
      allChartOptions: ["Line", "Bar", "Doughnut"],
      defaultSuggestedChartType: "",
      defaultSuggestedX: "",
      defaultSuggestedY: "",
    };
  },
  mounted() {
    // Einlesen
    this.fetchData();
  },
  methods: {
    fetchData() {
      axios
        .get(
          `${this.$env.content.datasetDetails.distributions.visualisationServiceUrl}/dataPreview`,
          {
            params: {
              urlString: this.downloadUrl,
              fileFormat: this.format,
            },
          }
        )
        .then((response) => {
          this.jsonData = response.data;
          this.invalidFile = false;
          this.addData();
          this.loading = false;
        })
        .catch((err) => {
          console.error('ERROR', err.message);
          this.loading = false;
          this.invalidFile = true;
          this.errorMessage = err.message;
        });
    },
    showTab(tabName) {
      this.activeTab = tabName;
    },
    // Once the JSON record is fetched, this method is called to fill all the data() fields with the necessary data
    addData() {
      this.activeTab = 'table-view';
      this.allLabels = this.jsonData.labels.all_labels;
      this.numericalLabels = this.jsonData.labels.numerical_labels;
      if (this.numericalLabels.length == 0) this.showNumTabContent = false;
      this.categoricalLabels = this.jsonData.labels.categorical_labels;
      if (this.categoricalLabels.length == 0) {
        this.showCatTabContent = false;
        // this.showXLabels = false;
      }
      this.viewType = this.jsonData.default_view_options.default_numerical_chart;
      this.xPicked = this.jsonData.default_view_options.default_axes.numerical_chart.x;
      this.yPicked = this.jsonData.default_view_options.default_axes.numerical_chart.y;

      this.catViewType = this.jsonData.default_view_options.default_categorical_chart;
      this.catYPicked = this.jsonData.default_view_options.default_axes.categorical_chart;
      this.dataRows = this.jsonData.data; // this line can take time
      if (!this.toIndex)
        this.toIndex = this.dataRows.length < 100 ? this.dataRows.length : 100;
      this.categorizedData = this.jsonData.categorized;

      let yValues = this.dataRows
        .map((e) => e[this.yPicked[0]])
        .slice(this.fromIndex - 1, this.toIndex);
      this.datasets[0] = {
        label: this.yPicked[0],
        data: yValues,
        backgroundColor: "#001D85",
        borderColor: "#001D85",
        borderWidth: 1,
      };

      this.defaultSuggestedChartType = this.allChartOptions[0];
      this.defaultSuggestedX = this.categoricalLabels[0];
      this.defaultSuggestedY = this.numericalLabels[0] ? [this.numericalLabels[0]] : [];
    },
    fillNumPlotData() {
      // In case there are no assigned lables, create empty lables (chart.js needs an array of lables, otherwise empty chart will display)
      if (this.xLabels.length === 0 || this.hideXLabels) {
        let emptyValues = Array(this.datasets[0].data.length).fill("");
        this.dataCollection = {
          labels: emptyValues,
          datasets: structuredClone((this.datasets.value)),
        };
      } else {
        let tmpDatasets = JSON.parse(JSON.stringify(this.datasets));
        for (let i = 0; i < tmpDatasets.length; i++) {
          tmpDatasets[i].data = this.datasets[i].data.slice(
            this.fromIndex - 1,
            this.toIndex
          );
        }
        this.xLabels = this.chartLabels.slice(this.fromIndex - 1, this.toIndex);
        this.dataCollection = {
          labels: this.xLabels,
          datasets: tmpDatasets,
        };
      }
    },
    fillCatPlotData() {
      this.catChartValues = Object.keys(
        this.categorizedData.find((e) => e.column === this.catYPicked)
          .categories
      ).slice(0, this.nCatToShow); // get array of all category names of yPicked
      this.catYValues = Object.values(
        this.categorizedData.find((e) => e.column === this.catYPicked)
          .categories
      ).slice(0, this.nCatToShow); // get array of all category counts of yPicked
      (this.catDatasets[0] = {
        label: this.catYPicked,
        data: this.catYValues,
        backgroundColor: this.catYValues.map(() => this.randomColor()),
      }),
        (this.catDataCollection = {
          labels: this.catChartValues,
          datasets: JSON.parse(JSON.stringify(this.catDatasets)).slice(
            0,
            this.nCatToShow
          ),
        });
    },
    updateRange() {
      this.fillNumPlotData();
    },
    // Called when user chooses or removes new Y-Lables
    updateXPicked(label) {
      this.xPicked = label;
    },
    updateYPicked(label) {
      if (this.datasets.map((e) => e.label).includes(label)) {
        let index = this.yPicked.indexOf(label);
        if (index > -1) {
          // only splice array when item is found
          this.yPicked.splice(index, 1); // 2nd parameter means remove one item only
        }
        this.removeChart(label);
      } else {
        this.yPicked.push(label);
        this.addSelectedChart(label);
      }
    },
    updateCatYPicked(label) {
      this.catYPicked = label;
    },
    addSelectedChart(label) {
      let yTmpValues = this.dataRows.map((e) => e[label]);
      const randomColor = this.randomColor();
      this.datasets.push({
        label: label,
        data: yTmpValues.slice(this.fromIndex - 1, this.toIndex),
        backgroundColor: randomColor,
        borderColor: randomColor,
        borderWidth: 1,
      });
      this.fillNumPlotData();
    },
    removeChart(label) {
      this.datasets = this.datasets.filter((o) => o.label !== label);
      this.fillNumPlotData();
    },
    randomColor() {
      const letters = "0123456789ABCDEF";
      let color = "#";
      for (let i = 0; i < 6; i++) {
        color += letters[Math.floor(Math.random() * 16)];
      }
      return color;
    },
  },
  watch: {
    xPicked() {
      this.$emit("input", this.xPicked);
      this.chartLabels = this.dataRows
        .map((e) => e[this.xPicked])
        .slice(this.fromIndex - 1, this.toIndex);
      this.xLabels = this.chartLabels;
      this.fillNumPlotData();
    },
    hideXLabels() {
      this.fillNumPlotData();
    },
    catViewType() {
      if (this.catViewType === "Pie") this.nCatToShow = 20;
      else if (this.catViewType === "Bar") this.nCatToShow = 50;
      else if (this.catViewType === "Line") this.nCatToShow = 100;
      // this.$emit("input", this.catYPicked);
      this.fillCatPlotData();
    },
    catYPicked() {
      this.$emit("input", this.catYPicked);
      this.fillCatPlotData();
    },
  },
};
</script>

<style lang="scss">
.dv-preview-container {
  /* padding: 3px; */
  /* border-bottom: 1px solid gray;
        border-top: 1px solid gray; */
  max-width: 100%;
  overflow: auto;
  overflow-y: hidden;
  // display: none;
}

.dv-preview-container .card-header {
  background-color: transparent;
}

.dv-preview-container .card {
  border: none;
}

.dv-nav-tabs li .nav-link {
  color: inherit;
  &.active {
    // background-color: oldlace;
    font-weight: bold;
    color: var(--primary-light);
    border-top: 4px solid var(--primary-light);
    margin-bottom: -2px;
  }
  &:hover:not(.active) {
    border-color: transparent;
  }
}

.dv-numtab-content canvas {
  max-width: 100%;
}

.dv-add-btn {
  height: 48px;
  align-self: end;
  background-color: var(--primary-light);
  color: white;

  &:hover {
    color: white;
  }
}

.dv-records-range-container {
  margin-right: 20px;
}

.dv-records-range-container input {
  text-align: center;
  width: 50px;
}

.dv-records-range-container-record-number {
  background-color: #f0efed;
  border-radius: 5px;
  padding: 10px 15px;
  font-weight: 650;
}

.dv-records-range-container small label {
  padding: 0 5px;
}

.dv-table-wrapper {
  max-width: 1108px;
  overflow: auto;
}

.dv-dist-table {
  margin: 15px 0;
}

.dv-dist-table td,
.dv-dist-table th {
  border: 1px solid #dfe2e5;
  padding: 0.6em 1em;
}

.dv-dist-table tr:nth-child(2n) {
  background-color: #f6f8fa;
}

.dv-feedback-tool-wrapper {
  padding: 5px 15px;
  margin: 15px 0;
  background-color: #f6f8fa;
  border: 1px solid #f6f8fa;
  border-radius: 5px;
}

.dv-canvas-container canvas {
  max-height: 500px;
}
</style>
